<?php
namespace RevPDFLib\Tests;

use RevPDFLib\Items\Element\AbstractElement;

/**
 * Test class for AbstractElement.
 * Generated by PHPUnit on 2012-02-12 at 11:07:53.
 */
class AbstractElementTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @var AbstractElement
     */
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp()
    {
        $this->object = $this->getMockForAbstractClass('\RevPDFLib\Items\Element\AbstractElement', array(), '', false);
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown()
    {
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getPosx
     * @todo Implement testGetPosx().
     */
    public function testGetPosx()
    {
        $this->object->setPosx(50);
        $this->assertEquals(50, $this->object->getPosx());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setPosx
     */
    public function testSetPosx()
    {
        $this->object->setPosx(50);
        $this->assertEquals(50, $this->object->getPosx());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getPosy
     * @todo Implement testGetPosy().
     */
    public function testGetPosy()
    {
        $this->object->setPosy(100);
        $this->assertEquals(100, $this->object->getPosy());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setPosy
     */
    public function testSetPosy()
    {
        $this->object->setPosy(100);
        $this->assertEquals(100, $this->object->getPosy());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getFont
     */
    public function testGetFont()
    {
        $this->object->setFont('arial');
        $this->assertEquals('arial', $this->object->getFont());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setFont
     */
    public function testSetFont()
    {
        $this->object->setFont('arial');
        $this->assertEquals('arial', $this->object->getFont());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::isAutoExtend
     */
    public function testIsAutoExtend()
    {
        $this->object->setAutoExtend(1);
        $this->assertEquals(1, $this->object->isAutoExtend());
        $this->object->setAutoExtend(0);
        $this->assertEquals(0, $this->object->isAutoExtend());
        $this->object->setAutoExtend('yes');
        $this->assertEquals(0, $this->object->isAutoExtend());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setAutoExtend
     */
    public function testSetIsAutoExtend()
    {
        $this->object->setAutoExtend(1);
        $this->assertEquals(1, $this->object->isAutoExtend());
        $this->object->setAutoExtend(0);
        $this->assertEquals(0, $this->object->isAutoExtend());
        $this->object->setAutoExtend('yes');
        $this->assertEquals(0, $this->object->isAutoExtend());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getStyle
     */
    public function testGetStyle()
    {
        $this->object->setStyle('UIBN');
        $this->assertEquals('UIBN', $this->object->getStyle());
        $this->object->setStyle('UIBNEZ');
        $this->assertEquals('UIBN', $this->object->getStyle());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setStyle
     * @todo Implement testSetStyle().
     */
    public function testSetStyle()
    {
        $this->object->setStyle('UIBN');
        $this->assertEquals('UIBN', $this->object->getStyle());
        $this->object->setStyle('UIBNEZ');
        $this->assertEquals('UIBN', $this->object->getStyle());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getFontSize
     */
    public function testGetFontSize()
    {
        $this->object->setFontSize('12');
        $this->assertEquals('12', $this->object->getFontSize());
        $this->object->setFontSize('A');
        $this->assertEquals('12', $this->object->getFontSize());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setFontSize
     * @todo Implement testSetFontSize().
     */
    public function testSetFontSize()
    {
        $this->object->setFontSize('12');
        $this->assertEquals('12', $this->object->getFontSize());
        $this->object->setFontSize('A');
        $this->assertEquals('12', $this->object->getFontSize());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getWidth
     */
    public function testGetWidth()
    {
        $this->object->setWidth('12');
        $this->assertEquals(12, $this->object->getWidth());
        $this->object->setWidth('A');
        $this->assertEquals(0, $this->object->getWidth());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setWidth
     */
    public function testSetWidth()
    {
        $this->object->setWidth('12');
        $this->assertEquals(12, $this->object->getWidth());
        $this->object->setWidth('A');
        $this->assertEquals(0, $this->object->getWidth());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getHeight
     */
    public function testGetHeight()
    {
        $this->object->setHeight('12');
        $this->assertEquals(12, $this->object->getHeight());
        $this->object->setHeight('A');
        $this->assertEquals(0, $this->object->getHeight());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setHeight
     * @todo Implement testSetHeight().
     */
    public function testSetHeight()
    {
        $this->object->setHeight('12');
        $this->assertEquals(12, $this->object->getHeight());
        $this->object->setHeight('A');
        $this->assertEquals(0, $this->object->getHeight());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getHeightOffset
     */
    public function testGetHeightOffset()
    {
        $this->object->setHeightOffset('12');
        $this->assertEquals(12, $this->object->getHeightOffset());
        $this->object->setHeightOffset('A');
        $this->assertEquals(0, $this->object->getHeightOffset());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setHeightOffset
     */
    public function testSetHeightOffset()
    {
        $this->object->setHeightOffset('12');
        $this->assertEquals(12, $this->object->getHeightOffset());
        $this->object->setHeightOffset('A');
        $this->assertEquals(0, $this->object->getHeightOffset());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getBorder
     */
    public function testGetBorder()
    {
        $this->object->setBorder('L');
        $this->assertEquals('L', $this->object->getBorder());
        $this->object->setBorder('LR');
        $this->assertEquals('LR', $this->object->getBorder());
        $this->object->setBorder('LRB');
        $this->assertEquals('LRB', $this->object->getBorder());
        $this->object->setBorder('LRBT');
        $this->assertEquals('LRBT', $this->object->getBorder());
        $this->object->setBorder('LRéBTAé');
        $this->assertEquals('LRBT', $this->object->getBorder());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setBorder
     */
    public function testSetBorder()
    {
        $this->object->setBorder('L');
        $this->assertEquals('L', $this->object->getBorder());
        $this->object->setBorder('LR');
        $this->assertEquals('LR', $this->object->getBorder());
        $this->object->setBorder('LRB');
        $this->assertEquals('LRB', $this->object->getBorder());
        $this->object->setBorder('LRBT');
        $this->assertEquals('LRBT', $this->object->getBorder());
        $this->object->setBorder('LRéBTAé');
        $this->assertEquals('LRBT', $this->object->getBorder());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getBorderWidth
     */
    public function testGetBorderWidth()
    {
        $this->object->setBorderWidth('1');
        $this->assertEquals('1', $this->object->getBorderWidth());
        $this->object->setBorderWidth('0.2');
        $this->assertEquals('0.2', $this->object->getBorderWidth());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setBorderWidth
     */
    public function testSetBorderWidth()
    {
        $this->object->setBorderWidth('1');
        $this->assertEquals('1', $this->object->getBorderWidth());
        $this->object->setBorderWidth('0.2');
        $this->assertEquals('0.2', $this->object->getBorderWidth());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getAlignment
     */
    public function testGetAlignment()
    {
        $this->object->setAlignment('L');
        $this->assertEquals('L', $this->object->getAlignment());
        $this->object->setAlignment('C');
        $this->assertEquals('C', $this->object->getAlignment());
        $this->object->setAlignment('R');
        $this->assertEquals('R', $this->object->getAlignment());
        $this->object->setAlignment('Z');
        $this->assertEquals('L', $this->object->getAlignment());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setAlignment
     */
    public function testSetAlignment()
    {
        $this->object->setAlignment('L');
        $this->assertEquals('L', $this->object->getAlignment());
        $this->object->setAlignment('C');
        $this->assertEquals('C', $this->object->getAlignment());
        $this->object->setAlignment('R');
        $this->assertEquals('R', $this->object->getAlignment());
        $this->object->setAlignment('Z');
        $this->assertEquals('L', $this->object->getAlignment());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getFillColor
     */
    public function testGetFillColor()
    {
        $this->object->setFillColor('FFF');
        $this->assertEquals('#FFF', $this->object->getFillColor());
        $this->object->setFillColor('#FFF');
        $this->assertEquals('#FFF', $this->object->getFillColor());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setFillColor
     */
    public function testSetFillColor()
    {
        $this->object->setFillColor('FFF');
        $this->assertEquals('#FFF', $this->object->getFillColor());
        $this->object->setFillColor('#FFF');
        $this->assertEquals('#FFF', $this->object->getFillColor());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getFillStyle
     */
    public function testGetFillStyle()
    {
        $this->object->setFillStyle('F');
        $this->assertEquals('F', $this->object->getFillStyle());
        $this->object->setFillStyle('D');
        $this->assertEquals('D', $this->object->getFillStyle());
        $this->object->setFillStyle('FD');
        $this->assertEquals('FD', $this->object->getFillStyle());
        $this->object->setFillStyle('FDX');
        $this->assertEquals('FD', $this->object->getFillStyle());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setFillStyle
     */
    public function testSetFillStyle()
    {
        $this->object->setFillStyle('F');
        $this->assertEquals('F', $this->object->getFillStyle());
        $this->object->setFillStyle('D');
        $this->assertEquals('D', $this->object->getFillStyle());
        $this->object->setFillStyle('FD');
        $this->assertEquals('FD', $this->object->getFillStyle());
        $this->object->setFillStyle('FDX');
        $this->assertEquals('FD', $this->object->getFillStyle());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getTextColor
     */
    public function testGetTextColor()
    {
        $this->object->setTextColor('FFF');
        $this->assertEquals('#FFF', $this->object->getTextColor());
        $this->object->setTextColor('#FFF');
        $this->assertEquals('#FFF', $this->object->getTextColor());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setTextColor
     */
    public function testSetTextColor()
    {
        $this->object->setTextColor('FFF');
        $this->assertEquals('#FFF', $this->object->getTextColor());
        $this->object->setTextColor('#FFF');
        $this->assertEquals('#FFF', $this->object->getTextColor());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getFormat
     */
    public function testGetFormat()
    {
        $this->object->setFormat('string');
        $this->assertEquals('string', $this->object->getFormat());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setFormat
     */
    public function testSetFormat()
    {
        $this->object->setFormat('string');
        $this->assertEquals('string', $this->object->getFormat());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::getType
     */
    public function testGetType()
    {
        $this->object->setType('string');
        $this->assertEquals('string', $this->object->getType());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setType
     */
    public function testSetType()
    {
        $this->object->setType('string');
        $this->assertEquals('string', $this->object->getType());
    }

    /**
     * @covers RevPDFLib\Items\Element\AbstractElement::setProperties
     * @todo Implement testSetProperties().
     */
    public function testSetProperties()
    {
        $data = array(
            'x' => 10,
            'y' => 12,
            'width' => 50,
            'height' => 60,
            'border' => 1,
            'borderWidth' => '0.5',
            'type' => 'textfield',
            'value' => 'éàç€',
            'textAlignment' => '',
            'format' => 'text',
            'forecolor' => '#FDA',
            'backcolor' => '#ADF',
            'font' => array(
                'fontName' => 'courier',
                'size' => 14,
                'isUnderline' => true,
                'isBold' => false,
                'isItalic' => true
            )
        );
        $this->object->setProperties($data);

        $this->assertEquals(10, $this->object->getPosX());
        $this->assertEquals(12, $this->object->getPosY());
        $this->assertEquals(50, $this->object->getWidth());
        $this->assertEquals(60, $this->object->getHeight());
        $this->assertEquals(1, $this->object->getBorder());
        $this->assertEquals('0.5', $this->object->getBorderWidth());
        $this->assertEquals('UI', $this->object->getStyle());
        $this->assertEquals('textfield', $this->object->getType());
        $this->assertEquals('éàç€', $this->object->getField());
        $this->assertEquals('UI', $this->object->getStyle());
        $this->assertEquals('courier', $this->object->getFont());
        $this->assertEquals('14', $this->object->getFontSize());
        $this->assertEquals('#FDA', $this->object->getTextColor());
        $this->assertEquals('#ADF', $this->object->getFillColor());
    }

    public function testStyle()
    {
        $data = array(
            'posX' => 10,
            'posY' => 12,
            'width' => 50,
            'height' => 60,
            'border' => 1,
            'borderWidth' => '0.5',
            'type' => 'textfield',
            'value' => 'éàç€',
            'textAlignment' => '',
            'format' => 'text',
            'forecolor' => '#FDA',
            'backcolor' => '#ADF',
            'font' => array(
                'fontName' => 'DejaVu',
                'size' => 14,
                'isUnderline' => false,
                'isBold' => false,
                'isItalic' => false
            )
        );
        $this->object->setProperties($data);

        $this->assertEquals('', $this->object->getStyle());
    }

}
