<?php

namespace RevPDFLib\Tests;

use RevPDFLib\Items\Element\FactoryElement;

/**
 * Test class for FactoryElement.
 * Generated by PHPUnit on 2012-02-12 at 11:44:42.
 */
class FactoryElementTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @var FactoryElement
     */
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp()
    {
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown()
    {
    }

    /**
     * @covers RevPDFLib\Items\Element\FactoryElement::getFactory
     * @todo Implement testGetFactory().
     */
    public function testGetFactory()
    {
        $this->object = FactoryElement::getFactory('textfield');
        $this->assertInstanceOf('RevPDFLib\Items\Element\Textfield', $this->object);
        $this->object = FactoryElement::getFactory('textzone');
        $this->assertInstanceOf('RevPDFLib\Items\Element\Textzone', $this->object);
        $this->object = FactoryElement::getFactory('pagenumber');
        $this->assertInstanceOf('RevPDFLib\Items\Element\Pagenumber', $this->object);
        $this->object = FactoryElement::getFactory('image');
        $this->assertInstanceOf('RevPDFLib\Items\Element\Image', $this->object);
        $this->object = FactoryElement::getFactory('roundedbox');
        $this->assertInstanceOf('RevPDFLib\Items\Element\Roundedbox', $this->object);
        $this->object = FactoryElement::getFactory('rectangle');
        $this->assertInstanceOf('RevPDFLib\Items\Element\Rectangle', $this->object);
        $this->object = FactoryElement::getFactory('line');
        $this->assertInstanceOf('RevPDFLib\Items\Element\Line', $this->object);
    }

    /**
     * @covers RevPDFLib\Items\Element\FactoryElement::getFactory
     *
     * @expectedException        InvalidArgumentException
     * @expectedExceptionMessage Type NOT supported : qsd
     */
    public function testException()
    {
        $this->object = FactoryElement::getFactory('qsd');
    }

}
